#!/usr/bin/python
# -*- coding: utf-8 -*-
import xbmc,xbmcgui,xbmcplugin,xbmcaddon,urllib,sys,os,re,time
_handle_ = int(sys.argv[1])

def de_en_code_path(path):
    if sys.platform.startswith('win'):return xbmc.translatePath(path).decode('utf-8')
    else:return xbmc.translatePath(path).encode('utf-8')

_addon_ =  xbmcaddon.Addon()
_addon_path_ = de_en_code_path(_addon_.getAddonInfo('path'))

_icon_png_ = os.path.join(_addon_path_,'icon.png')
sys.path.append(os.path.join(_addon_path_,'resources','lib'))
import requests
import cfscraper

_provisional_headers_ = {
    'User-Agent':'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:60.0) Gecko/20100101 Firefox/60.0',
    'Accept-Language':'de-de,de;q=0.8,en-us;q=0.5,en;q=0.3',
    'Accept':'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
    'Connection':'keep-alive'}

def get_cf_request_session(url,headers_dict=None):
    session = requests.session()
    if not headers_dict == None:
        session.headers.update(headers_dict)
    scraper = cfscraper.create_scraper(sess=session)
    return scraper.get(url).content

def add_dir(name,url,mode,iconimage):
    u=sys.argv[0]+'?url='+urllib.quote_plus(url)+'&mode='+str(mode)+'&name='+urllib.quote_plus(name)+'&iconimage='+urllib.quote_plus(iconimage)
    listitem=xbmcgui.ListItem(name, iconImage='DefaultFolder.png', thumbnailImage=iconimage)
    listitem.setInfo(type='video',infoLabels={'Title':name} )
    xbmcplugin.addDirectoryItem(handle=_handle_,url=u,listitem=listitem,isFolder=True)

def regex_1(content):
    url_check_array = []
    for url,img,title in re.compile('<\/a><a class="s1-eo-uninherit"[\s\S]*?href="(.*?)"[\s\S]*?src="(.*?)"[\s\S]*?alt="(.*?)"', re.DOTALL).findall(content):
        if not url in url_check_array:
            url_check_array.append(url)
            add_dir(title.upper(),url,2,img)

def regex_2(content):
    url_check_array = []
    for url,img,title in re.compile('<a class="s1-eo-uninherit s1-eo-more-broadcasts"[\s\S]*?href="(.*?)"[\s\S]*?src="(.*?)"[\s\S]*?alt="(.*?)"', re.DOTALL).findall(content):
        if not url in url_check_array:
            url_check_array.append(url)
            add_dir(title.upper(),url,3,img)

def regex_play_url(content):
    match = re.compile('data-url="(.*?)"', re.DOTALL).search(content)
    if match :return match.group(1).strip()

def play(title,url,img):
    player = xbmc.Player()
    if player.isPlaying(): 
        endtime = time.time()+5
        while player.isPlaying() and time.time() < endtime:player.stop()
    listitem = xbmcgui.ListItem(title,iconImage=img,thumbnailImage=img)
    listitem.setInfo('video',{'Title':title } )
    listitem.setProperty('IsPlayable','true')
    player.play(url,listitem)
    sys.exit(0)

def get_params():
    param=[]
    paramstring=sys.argv[2]
    if len(paramstring)>=2:
        params=sys.argv[2]
        cleanedparams=params.replace('?','')
        if (params[len(params)-1]=='/'):
            params=params[0:len(params)-2]
        pairsofparams=cleanedparams.split('&')
        param={}
        for i in range(len(pairsofparams)):
            splitparams={}
            splitparams=pairsofparams[i].split('=')
            if (len(splitparams))==2:
                param[splitparams[0]]=splitparams[1]                         
        return param
params=get_params()

url=None
try:url=urllib.unquote_plus(params['url'])
except:pass
name=None
try:name=urllib.unquote_plus(params['name'])
except:pass
iconimage=None
try:iconimage=urllib.unquote_plus(params['iconimage'])
except:pass
mode=None
try:mode=int(params['mode'])
except:pass

if mode == None:
    add_dir('EOTV LIVE STREAM','http://cdn-europe.smartcast.de:1935/eotv/eotvhd/playlist.m3u8?scheme=m3u8',4,_icon_png_)
    add_dir('SERIEN','http://eotv.de/serien/',1,_icon_png_)
    add_dir('MOVIES','http://eotv.de/movies/',1,_icon_png_)
    add_dir('CLIPS','http://eotv.de/clips/',1,_icon_png_)

elif mode == 1:
    content = get_cf_request_session(url,_provisional_headers_)
    regex_1(content)

elif mode == 2:
    content = get_cf_request_session(url,_provisional_headers_)
    regex_2(content)

elif mode == 3:
    content = get_cf_request_session(url,_provisional_headers_)
    play_url = regex_play_url(content)
    play(name,play_url,iconimage)

elif mode == 4:
    play(name,url,iconimage)

xbmcplugin.endOfDirectory(handle=_handle_,succeeded=True,updateListing=False,cacheToDisc=False)